/*
 * 
 *  This file is part of Sourceprojects.org Lycia Copyright 2010 noctarius
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 * 
 */
package org.sourceprojects.lyciaspringintegration;

import org.sourceprojects.lycia.ResourceResolver;
import org.sourceprojects.lycia.ResourceResolverFactory;
import org.sourceprojects.lycia.LyciaOsgiFactory;
import org.springframework.beans.factory.FactoryBean;

/**
 * 
 * @author noctarius
 * @since 1.9.1
 */
public class ResourceResolverSpringFactory implements FactoryBean {
	private LyciaOsgiFactory osgiFactory = null;

	public Object getObject() throws Exception {
		if (osgiFactory != null) {
			return osgiFactory.newResourceResolverInstance();
		}

		return ResourceResolverFactory.newInstance(getClass().getClassLoader());
	}

	public Class<?> getObjectType() {
		return ResourceResolver.class;
	}

	public boolean isSingleton() {
		return false;
	}

	public void setOsgiFactory(LyciaOsgiFactory osgiFactory) {
		this.osgiFactory = osgiFactory;
	}

	public LyciaOsgiFactory getOsgiFactory() {
		return osgiFactory;
	}
}
